SystemOrganization addCategory: #'Sight-Path-Omni'!

MwMethodWrapper subclass: #SInstanceCountingWrapper
	instanceVariableNames: 'instances'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SInstanceCountingWrapper class methodsFor: 'instance creation' stamp: 'bs 7/6/2010 15:02:29.619'!
installInClass: aClass
	^ (self on: #basicNew inClass: aClass class)	
		install;
		yourself	! !

!SInstanceCountingWrapper methodsFor: 'accessing' stamp: 'bs 7/6/2010 14:49:29.747'!
instances
	^ instances ifNil: [ instances := OrderedCollection new ]! !

!SInstanceCountingWrapper methodsFor: 'accessing' stamp: 'bs 7/6/2010 14:47:40.164'!
instances: anObject
	instances := anObject! !

!SInstanceCountingWrapper methodsFor: 'as yet unclassified' stamp: 'bs 7/6/2010 15:12:52.346'!
numberOf: anInstance
	^ self instances indexOf: anInstance.! !

!SInstanceCountingWrapper methodsFor: 'evaluating' stamp: 'bs 7/6/2010 14:51:44.236'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	| newInstance |
	newInstance := self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.
	self instances add: newInstance.
	^ newInstance.! !

MwMethodWrapper subclass: #SReceiverRecordingWrapper
	instanceVariableNames: 'receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SReceiverRecordingWrapper methodsFor: 'accessing' stamp: 'bs 7/6/2010 14:15:16.894'!
receiver
	^ receiver! !

!SReceiverRecordingWrapper methodsFor: 'accessing' stamp: 'bs 7/6/2010 14:15:16.9'!
receiver: anObject
	receiver := anObject! !

!SReceiverRecordingWrapper methodsFor: 'evaluating' stamp: 'bs 7/6/2010 14:14:54.255'!
valueWithReceiver: anObject arguments: anArrayOfObjects
	self receiver: anObject.
	^ self clientMethod valueWithReceiver: anObject arguments: anArrayOfObjects.! !

Object subclass: #SActivation
	instanceVariableNames: 'method number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SActivation class methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:47:02.386'!
method: aCompiledMethod number: anInteger
	^ self new
		method: aCompiledMethod;
		number: anInteger;
		yourself! !

!SActivation methodsFor: 'accessing' stamp: 'bs 7/18/2010 12:42:39.512'!
method
	^ method! !

!SActivation methodsFor: 'accessing' stamp: 'bs 7/18/2010 12:42:39.525'!
method: anObject
	method := anObject! !

!SActivation methodsFor: 'accessing' stamp: 'bs 7/18/2010 12:42:51.362'!
number
	^ number! !

!SActivation methodsFor: 'accessing' stamp: 'bs 7/18/2010 12:42:51.375'!
number: anObject
	number := anObject! !

Object subclass: #SOmni
	instanceVariableNames: 'entryPoint activation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SOmni class methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 12:45:11.945'!
entryPoint: anEntryPoint activation: anActivation
	^ SOmni new
		entryPoint: anEntryPoint;
		activation: anActivation;
		yourself
		! !

!SOmni methodsFor: 'accessing' stamp: 'bs 7/18/2010 12:44:29.664'!
activation
	^ activation! !

!SOmni methodsFor: 'accessing' stamp: 'bs 7/18/2010 12:44:29.678'!
activation: anObject
	activation := anObject! !

!SOmni methodsFor: 'accessing' stamp: 'bs 7/18/2010 12:44:41.016'!
activationMethod
	^ self activation method! !

!SOmni methodsFor: 'accessing' stamp: 'bs 7/18/2010 12:44:50.649'!
activationNumber
	^ self activation number! !

!SOmni methodsFor: 'accessing' stamp: 'bs 7/17/2010 16:34:37.582'!
entryPoint
	^ entryPoint! !

!SOmni methodsFor: 'accessing' stamp: 'bs 7/17/2010 16:34:37.733'!
entryPoint: anObject
	entryPoint := anObject! !

!SOmni methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 14:08:03.105'!
receiverClass
	| wrapper nActivations receiverClass |
	wrapper := MwBlockMethodWrapper 
		on: self activationMethod selector 
		inClass: self activationMethod methodClass. 
	wrapper install.
	nActivations := 0.
	wrapper beforeBlock: [:receiver :args | 
		nActivations := nActivations + 1.
		(nActivations = self activationNumber) 
			ifTrue: [ receiverClass := receiver class ] ].
	[ self entryPoint execute ] ensure: [ wrapper uninstall ].
	^ receiverClass! !

!SOmni methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 14:33:42.523'!
whereWasValue: aValue assignedTo: instVarName
	| wrapper wrappers assigningActivations inspectedMethodWrapper inspectedMethodCalls reachedInspectedActivation receiverClass lastActivationMethod lastActivationNumber |
	receiverClass := self receiverClass.
	assigningActivations := OrderedCollection new.
	wrappers := Set new.
	" ist es gnstiger erst die instanz zu bestimmen und danach die entscheidende zuweisung, oder beides in einem lauf"
	" erst beginnen bei der richtigen instanz "
	" aufhren, nach der n-ten aktivierung" 
	
	reachedInspectedActivation := false.
	inspectedMethodCalls := 0.
	inspectedMethodWrapper := self wrap: self activationMethod using: MwBlockMethodWrapper.
	inspectedMethodWrapper beforeBlock: [ :receiver :args | 
		inspectedMethodCalls := inspectedMethodCalls + 1. 
		(self activationNumber = inspectedMethodCalls) 
			ifTrue: [ reachedInspectedActivation := true. ] ].
	
	receiverClass withAllSuperclassesDo: [ :c | 
		(c whichSelectorsAssign: instVarName) do: [ :s | 
			wrapper := self wrapOn: s inClass: c using: MwBlockMethodWrapper.
			wrappers add: wrapper.
			wrapper afterBlock: [ :receiver :arguments |
				reachedInspectedActivation 
					ifFalse: [  assigningActivations add: wrapper clientMethod ] ] ] ].
	
	[ self entryPoint execute ] 
		ensure: [ 
			wrappers do: [ :w | w uninstall ].
			inspectedMethodWrapper uninstall ].
	
	lastActivationMethod := assigningActivations last.
	lastActivationNumber := (assigningActivations collect: [ :m | m = lastActivationMethod ]) size.
	^ SActivation method: lastActivationMethod number: lastActivationNumber.! !

!SOmni methodsFor: 'as yet unclassified' stamp: 'bs 7/18/2010 13:10:48.896'!
wrap: aMethod using: aWrapperClass
	^ self wrapOn: aMethod selector inClass: aMethod methodClass using: aWrapperClass! !

!SOmni methodsFor: 'as yet unclassified' stamp: 'bs 7/17/2010 17:01:34.044'!
wrapOn: aSelector inClass: aClass using: aWrapperClass
	| wrapper |
	wrapper := aWrapperClass on: aSelector inClass: aClass.
	wrapper install.
	^ wrapper! !

STbTestCase subclass: #SOmniTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:33.081'!
exampleTestMethod
	^ (SOmniTbPersonTests >> #testFirstnameAccessors)! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/21/2010 21:26:47.546'!
testAssigningValues
	| sut  targetActivation |
	sut := SOmni
		entryPoint: (STestCaseEntryPoint testMethod: self exampleTestMethod) 
		activation: (SActivation method: self tbFirstnameGetter number: 2).
	self assert: self exampleMethod methodClass equals: sut receiverClass.
	
	targetActivation := sut whereWasValue: 'Paul' assignedTo: 'firstname'.
	self assert: (targetActivation isKindOf: SActivation).
	self assert: self tbFirstnameSetter equals: targetActivation method.
	self assert: 2 equals: targetActivation number.! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:46:16.974'!
testFooBar
	| sut timesCalled inspectedActivation wasCalled |
	self undoInTearDownDo: [
		sut := self wrap: self exampleMethod using: MwBlockMethodWrapper ].
		
	inspectedActivation := 1.
	timesCalled := 0.
	wasCalled := false.
	sut beforeBlock: [ :receiver :arguments |
		timesCalled := timesCalled + 1. 
		(inspectedActivation = timesCalled) ifTrue: [ wasCalled := true ] ].
	
	self runTbTests.
	self assert: true equals: wasCalled. ! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 13:30:33.781'!
testInstanceCounting
	| instanceCounter receiverRecorder nStdPasses |
	nStdPasses := self tbNumberOfExpectedPasses.
	
	instanceCounter := SInstanceCountingWrapper installInClass: STbPerson.
	receiverRecorder := self wrap: self exampleMethod using: SReceiverRecordingWrapper.
	self createdWrappers addAll: { instanceCounter. receiverRecorder }.
	
	self runTbTests.
	self assert: nStdPasses equals: (instanceCounter numberOf: receiverRecorder receiver)
	! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/17/2010 16:44:32.528'!
testLastActivationThatSetsInstVarToValue
	| calls instVarName wrapper currentCall isValueDifferent inspectedValue |
	calls := OrderedCollection new.
	instVarName := self exampleInstVarName.
	
	"receiver := self wrap: self exampleMethod using: SReceiverRecordingWrapper.
	self runExampleTests."
	
	inspectedValue := ''.
	
	self undoInTearDownDo: [
		self exampleSubclass withAllSuperclassesDo: [ :c | 
			(c whichSelectorsAssign: instVarName) do: [ :s | 
				wrapper := self wrapOn: s inClass: c using: MwBlockMethodWrapper.
				wrapper beforeBlock: [ :receiver :arguments |
					receiver instVarNamed: instVarName ] ] ] ].
	
	" schnittmenge aus den selektoren oben und dem call tree, anders berechnet, 
	  ich muss prfen ob die methoden auch gecovered werden "
	
	" ich merke mir, wie oft ein wrapper aufgerufen wird und 
	  bei welchem Aufruf der wert gesetzt wird. "
	
	" ich schreibe mir den wrapper weg "
	
	" merke ich mir den Wert vor oder hinter dem aufruf? - problem ist, 
	dass whrend eines methode, in welcher der wert gendert wird, auch die zielaktivierung erreicht wird
	in dem dynamischen extent ..."
	
	"bis zum n-ten Aufruf von firstname - inspected Activation" 
	STbEmployee whichSelectorsStoreInto: 'firstname'.
	"STbEmployee withAllSuperclasses select "
	! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 8/10/2010 18:46:04.502'!
testReceiverRecording
	| sut |
	sut := self wrap: self exampleMethod using: SReceiverRecordingWrapper.
	self runTbTests.
	self assert: sut receiver class equals: self exampleMethod methodClass.! !

!SOmniTestCase methodsFor: 'as yet unclassified' stamp: 'bs 7/17/2010 16:44:51.031'!
testToDo
	" all nodes, where a particular instance is accessed or modified - while modifying seems hard "
	" the path that leads to setting an inst var to the particular value or instance "
	" fr value, was ist die letzte stelle vor dem ausgewhlten punkt, 
	  an dem diese inst var auf folgenden wert gesetzt wird. "
	" fr value, was ist die letzte stelle, an der die inst var auf diese instanz gesetzt wird "
	! !

TestCase subclass: #SOmniTbPersonTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sight-Path-Omni'!

!SOmniTbPersonTests methodsFor: 'as yet unclassified' stamp: 'bs 3/3/2011 14:32:34.316'!
testFirstnameAccessors
	
	| aPerson paul |
	aPerson := STbPerson new.
	aPerson firstname: nil.
	self assert: nil equals: aPerson firstname.
	
	paul := STbPerson new.
	paul firstname: 'Paul'.
	self assert: 'Paul' equals: paul firstname.
	self assert: 'a STbPerson' equals: paul asString.
	
	paul := STbPerson new.
	paul firstname: 'Paul'.
	self assert: 'Paul' equals: paul firstname.
	self assert: 'a STbPerson' equals: paul asString! !
